from jinja2 import nodes
from jinja2.ext import Extension

from htmlmin import minify


class HTMLMinExtension(Extension):

    tags = {'minify'}

    def parse(self, parser):
        lineno = next(parser.stream).lineno
        body = parser.parse_statements(['name:endminify'], drop_needle=True)
        return nodes.CallBlock(self.call_method('_minify'), [], [], body).set_lineno(lineno)

    @staticmethod
    def _minify(caller):
        return minify(
            caller().unescape(),
            remove_comments=True,
            reduce_boolean_attributes=True,
            remove_optional_attribute_quotes=False
        ).strip()
